// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GCONFMM_CLIENT_H
#define _GCONFMM_CLIENT_H

#include <glibmm.h>

// -*- C++ -*-
/* $Id: client.hg,v 1.11 2002/04/29 13:07:34 murrayc Exp $ */

/* client.hg
 * 
 * Copyright (C) 2000-2002 GConfmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gconf/gconf-client.h>

#include <glibmm/object.h>

#include <glibmm/error.h>
#include <gconfmm/value.h>
#include <gconfmm/callback.h>
#include <gconfmm/entry.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GConfClient GConfClient;
typedef struct _GConfClientClass GConfClientClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Conf
{ class Client_Class; } // namespace Conf

} // namespace Gnome
namespace Gnome
{

namespace Conf
{

/** @addtogroup gconfmmEnums Enums and Flags */

/**
 * @ingroup gconfmmEnums
 */
enum ClientErrorHandlingMode
{
  CLIENT_HANDLE_NONE,
  CLIENT_HANDLE_UNRETURNED,
  CLIENT_HANDLE_ALL
};

} // namespace Conf

} // namespace Gnome

#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gnome::Conf::ClientErrorHandlingMode> : public Glib::Value_Enum<Gnome::Conf::ClientErrorHandlingMode>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Conf
{

/**
 * @ingroup gconfmmEnums
 */
enum ClientPreloadType
{
  CLIENT_PRELOAD_NONE,
  CLIENT_PRELOAD_ONELEVEL,
  CLIENT_PRELOAD_RECURSIVE
};

} // namespace Conf

} // namespace Gnome

#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gnome::Conf::ClientPreloadType> : public Glib::Value_Enum<Gnome::Conf::ClientPreloadType>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Conf
{


/** Exception class for Gnome::Conf::Client errors.
 */
class Error : public Glib::Error
{
public:
  enum Code
  {
    SUCCESS = 0,
    NO_SERVER = 2,
    NO_PERMISSION = 3,
    BAD_ADDRESS = 4,
    PARSE_ERROR = 6,
    CORRUPT = 7,
    TYPE_MISMATCH = 8,
    IS_DIR = 9,
    IS_KEY = 10,
    OVERRIDDEN = 11,
    OAF_ERROR = 12,
    LOCAL_ENGINE = 13,
    LOCK_FAILED = 14,
    NO_WRITABLE_DATABASE = 15,
    IN_SHUTDOWN = 16
  };

  explicit Error(GError* gobject);
  Code code() const;

#ifndef DOXYGEN_SHOULD_SKIP_THIS
private:
  static void throw_func(GError* gobject);
  friend void wrap_init(); // uses throw_func()
#endif
};

} // namespace Conf

} // namespace Gnome

#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gnome::Conf::Error::Code> : public Glib::Value_Enum<Gnome::Conf::Error::Code>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Conf
{


class Client : public Glib::Object
{
    public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Client          CppObjectType;
  typedef Client_Class    CppClassType;
  typedef GConfClient           BaseObjectType;
  typedef GConfClientClass      BaseClassType;

private:
  friend class Client_Class;
  static CppClassType client_class_;

  Client(const Client&);
  Client& operator=(const Client&); // not implemented

protected:
  explicit Client(GConfClient* castitem);
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Client();

  static Glib::RefPtr<Client> wrap_specific_type(GConfClient* gobject, bool take_copy = false); //Re-uses the existing wrapper, if it exists.

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type() G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */
  GConfClient* gobj()             { return (GConfClient*)(gobject_); }
  const GConfClient* gobj() const { return (GConfClient*)(gobject_); }

  GConfClient* gobj_copy();


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_value_changed(const Glib::ustring& key, const Value& value);
  virtual void on_unreturned_error(const Glib::Error& error);
  virtual void on_error(const Glib::Error& error);


private:
;
    
public:

    static Glib::RefPtr<Client> get_default_client();
    static Glib::RefPtr<Client> get_client_for_engine(GConfEngine* engine);

    void add_dir(const Glib::ustring& dir, ClientPreloadType preload = CLIENT_PRELOAD_NONE);
    
    void remove_dir(const Glib::ustring& dir);
    

    /// on_conf_change(guint cnxn_id, Entry entry)
    guint notify_add(const Glib::ustring& namespace_section, Callback callback);
    
    
    void notify_remove(guint cnxn);
    

    void set_error_handling(ClientErrorHandlingMode mode);
    
    
    void clear_cache();
    
    
    void preload(const Glib::ustring& dirname, ClientPreloadType type);
    ;
    
    Value get(const Glib::ustring& key);
    
    
    Value get_without_default(const Glib::ustring& key);
    
    
    Entry get_entry(const Glib::ustring& key,
		    const Glib::ustring& locale,
		    bool use_schema_default = true);
    
    
    Value get_default_from_schema(const Glib::ustring& key);
    
    
    bool unset(const Glib::ustring& key);
    
    
    typedef std::list<Entry> type_list_entries;
    type_list_entries all_entries(const Glib::ustring& dir);
    
    
    Glib::SArray all_dirs(const Glib::ustring& dir);
    
    
    void suggest_sync();
    
    
    bool dir_exists(const Glib::ustring& dir);
    
    
    bool key_is_writable(const Glib::ustring& key);
    
    
    gdouble get_float(const Glib::ustring& key);
    
    gint get_int(const Glib::ustring& key);
    
    Glib::ustring get_string(const Glib::ustring& key);
    
    bool get_bool(const Glib::ustring& key);
    
    
    Schema get_schema(const Glib::ustring& key);
    

    typedef std::list<Value> type_list_value;
    typedef std::list<gdouble> type_list_float;
    typedef std::list<int> type_list_int;
    typedef std::list<bool> type_list_bool;
    typedef std::list<Schema> type_list_schema;
    //TODO: list of pairs? Of every combination?!

    type_list_float get_list_of_floats(const Glib::ustring& key);
    type_list_int get_list_of_ints(const Glib::ustring& key);
    type_list_bool get_list_of_bools(const Glib::ustring& key);
    type_list_schema get_list_of_schemas(const Glib::ustring& key);
    Glib::SArray get_list_of_strings(const Glib::ustring& key);
    
    
    ValuePair get_pair(const Glib::ustring& key, ValueTypePair types);
    
    
    bool set(const Glib::ustring& key, gdouble val);
    
    bool set(const Glib::ustring& key, gint val);
    
    bool set(const Glib::ustring& key, const Glib::ustring& val);
    
    bool set(const Glib::ustring& key, bool val);
    
    
    bool set(const Glib::ustring& key, const Value& val);
    
    bool set(const Glib::ustring& key, const Schema& val);
    
    
    bool set(const Glib::ustring& key, const Glib::SArray& array);
    bool set(const Glib::ustring& key, const type_list_int& list);
    bool set(const Glib::ustring& key, const type_list_bool& list);
    bool set(const Glib::ustring& key, const type_list_float& list);
    bool set(const Glib::ustring& key, const type_list_schema& list);
    
    
    bool set(const Glib::ustring& key, const ValuePair &pair);
    
    
    /* FIXME: GConf::ChangeSet is not wrapped.
           
       bool commit_change_set (GConfChangeSet* cs, bool remove_committed);
       
       GConfChangeSet* reverse_change_set(GConfChangeSet* cs);
      
       GConfChangeSet* change_set_from_currentv(const SArray& keys);      
       GConfChangeSet* change_set_from_current (const Glib::ustring& first_key, ...);
    */

    
  /**
   * @par Prototype:
   * <tt>void %value_changed(const Glib::ustring& key, const Value& value)</tt>
   */
  Glib::SignalProxy2<void,const Glib::ustring&,const Value&> signal_value_changed();
;
    
  void value_changed (const Glib::ustring& key, const Value& value);;

    
  /**
   * @par Prototype:
   * <tt>void %unreturned_error(const Glib::Error& error)</tt>
   */
  Glib::SignalProxy1<void,const Glib::Error&> signal_unreturned_error();
;
    
  void unreturned_error(const Glib::Error& error);;

    
  /**
   * @par Prototype:
   * <tt>void %error(const Glib::Error& error)</tt>
   */
  Glib::SignalProxy1<void,const Glib::Error&> signal_error();
;
    
  void error(const Glib::Error& error);;
    
protected:
    void handle_error(GError* pError);
    
    GSList* get_list(const Glib::ustring& key, GConfValueType list_type);


};

} /* namespace Conf */
} /* namespace Gnome */


namespace Glib
{
  /** @relates Gnome::Conf::Client */
  Glib::RefPtr<Gnome::Conf::Client> wrap(GConfClient* object, bool take_copy = false);
}


#endif /* _GCONFMM_CLIENT_H */

